package com.sample;

import java.io.IOException;
import java.io.Reader;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.persistence.EntityManagerFactory;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.drools.SystemEventListenerFactory;
import org.jbpm.task.AccessType;
import org.jbpm.task.AllowedToDelegate;
import org.jbpm.task.Attachment;
import org.jbpm.task.BooleanExpression;
import org.jbpm.task.Comment;
import org.jbpm.task.Deadline;
import org.jbpm.task.Deadlines;
import org.jbpm.task.Delegation;
import org.jbpm.task.Escalation;
import org.jbpm.task.Group;
import org.jbpm.task.I18NText;
import org.jbpm.task.JBPMRole;
import org.jbpm.task.Notification;
import org.jbpm.task.OrganizationalEntity;
import org.jbpm.task.PeopleAssignments;
import org.jbpm.task.Reassignment;
import org.jbpm.task.Status;
import org.jbpm.task.Task;
import org.jbpm.task.TaskData;
import org.jbpm.task.User;
import org.jbpm.task.query.TaskSummary;
import org.jbpm.task.service.TaskService;
import org.jbpm.task.service.TaskServiceSession;
import org.jbpm.task.service.hornetq.HornetQTaskServer;
import org.jbpm.task.service.mina.MinaTaskServer;
import org.mvel2.MVEL;
import org.mvel2.ParserContext;
import org.mvel2.compiler.ExpressionCompiler;
import org.springframework.context.ApplicationContext;
import org.springframework.context.support.ClassPathXmlApplicationContext;

import com.oct.common.jbpm.TaskServiceFactory;
import com.oct.sys.bean.pojo.OAUser;
//


public class HumanTaskStartupServlet extends HttpServlet {
	
	
	 public void init() throws ServletException {
	        super.init();
	        TaskService taskService = TaskServiceFactory.createTaskService();
	        EntityManagerFactory emf = TaskServiceFactory.ENTITY_MANAGER_FACTORY;
	        TaskServiceSession taskSession = taskService.createSession();
	        List<String> listOaUser = emf.createEntityManager().createQuery("select u.userName from OAUser u").getResultList();
	        List<Integer> listOrg = emf.createEntityManager().createQuery("select u.id from Organization u").getResultList();
	        List<Integer> listRole = emf.createEntityManager().createQuery("select u.id from Role u").getResultList();
	        for (String userName : listOaUser) {
				taskSession.addUser(new User(userName));
			}
	        for (Integer orgId : listOrg) {
				taskSession.addGroup(new Group("group_"+orgId));
			}
	        
	        for (Integer roleId : listRole) {
				taskSession.addRole(new JBPMRole("role_"+roleId));
			}
	        // start server
	        HornetQTaskServer server = new HornetQTaskServer(taskService, 5445);
	        Thread thread = new Thread(server);
	        thread.start();
	        taskSession.dispose();
	        System.out.println("Task service started correctly !");
	        System.out.println("Task service running ...");
	 }
	 
	 public static Object eval(Reader reader, Map vars) {
	        try {
	            return eval( readerToString( reader ), vars );
	        } catch ( IOException e ) {
	            throw new RuntimeException( "Exception Thrown", e );
	        }
	    }
	    
	    public static String readerToString(Reader reader) throws IOException {
	        int charValue = 0;
	        StringBuffer sb = new StringBuffer( 1024 );
	        while ( (charValue = reader.read()) != -1 ) {
	            //result = result + (char) charValue;
	            sb.append( (char) charValue );
	        }
	        return sb.toString();
	    }

	    public static Object eval(String str, Map vars) {
	        ExpressionCompiler compiler = new ExpressionCompiler( str.trim() );

	        ParserContext context = new ParserContext();
	        context.addPackageImport( "org.jbpm.task" );
	        context.addPackageImport( "java.util" );
	        
	        context.addImport( "AccessType", AccessType.class );
	        context.addImport( "AllowedToDelegate", AllowedToDelegate.class );
	        context.addImport( "Attachment", Attachment.class );
	        context.addImport( "BooleanExpression", BooleanExpression.class );
	        context.addImport( "Comment", Comment.class );
	        context.addImport( "Deadline", Deadline.class );
	        context.addImport( "Deadlines", Deadlines.class );
	        context.addImport( "Delegation", Delegation.class );
	        context.addImport( "Escalation", Escalation.class );
	        context.addImport( "Group", Group.class );
	        context.addImport( "I18NText", I18NText.class );
	        context.addImport( "Notification", Notification.class );
	        context.addImport( "OrganizationalEntity", OrganizationalEntity.class );
	        context.addImport( "PeopleAssignments", PeopleAssignments.class );
	        context.addImport( "Reassignment", Reassignment.class );
	        context.addImport( "Status", Status.class );
	        context.addImport( "Task", Task.class );
	        context.addImport( "TaskData", TaskData.class );
	        context.addImport( "TaskSummary", TaskSummary.class );
	        context.addImport( "User", User.class );
	       //context.addImport( "JBPMRole", JBPMRole.class );

	        return MVEL.executeExpression( compiler.compile( context ), vars );
	    }
	 public void destroy() {
	        super.destroy();
	    }

	
	    protected void doGet(HttpServletRequest request,
	            HttpServletResponse response) throws ServletException, IOException {
	        //response.sendError(1001, "GET Method Not Allowed Here");
		doPost(request, response);
	    }

	    
	   
	    protected void doPost(HttpServletRequest reqquest,
	            HttpServletResponse response) throws ServletException, IOException {
	         response.sendError(1001, "POST Method Not Allowed Here");
	    }
}
